%
% ci001_der3.m
%
% This MATLAB function computes the third derivatives of the vector field
% defined in ci001_vf.m.
%
% der3_(n,i,j,k) is the third partial derivative of the n-th component
% of the vector field, taken with respect to the i-th, j-th and k-th variables.
%
% This file was generated by the program VFGEN (Version:2.4.0)
% Generated on 23-Feb-2009 at 16:56
%
%
function der3_ = ci001_der3(t,x_,p_)
    S_         = x_(1);
    P_         = x_(2);
    E_         = x_(3);
    I_         = x_(4);
    k_M_       = p_(1);
    k_I_       = p_(2);
    v_C_       = p_(3);

    der3_ = zeros(4,4,4,4);

    der3_(1,1,1,1) = -6*E_*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_+6*E_*S_*((1+I_*k_I_^(-1))*k_M_+S_)^(-4)*v_C_;
    der3_(1,1,1,3) = -2*S_*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_+2*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    der3_(1,1,3,1) = der3_(1,1,1,3);
    der3_(1,3,1,1) = der3_(1,1,1,3);
    der3_(1,1,1,4) = -4*E_*k_M_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_+6*E_*k_M_*S_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-4)*v_C_;
    der3_(1,1,4,1) = der3_(1,1,1,4);
    der3_(1,4,1,1) = der3_(1,1,1,4);
    der3_(1,1,3,4) = -2*k_M_*S_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_+k_M_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    der3_(1,1,4,3) = der3_(1,1,3,4);
    der3_(1,4,3,1) = der3_(1,1,3,4);
    der3_(1,3,1,4) = der3_(1,1,3,4);
    der3_(1,1,4,4) = 6*E_*k_M_^2*S_*k_I_^(-2)*((1+I_*k_I_^(-1))*k_M_+S_)^(-4)*v_C_-2*E_*k_M_^2*k_I_^(-2)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_;
    der3_(1,4,4,1) = der3_(1,1,4,4);
    der3_(1,4,1,4) = der3_(1,1,4,4);
    der3_(1,3,4,4) = -2*k_M_^2*S_*k_I_^(-2)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_;
    der3_(1,4,4,3) = der3_(1,3,4,4);
    der3_(1,4,3,4) = der3_(1,3,4,4);
    der3_(1,4,4,4) = 6*E_*k_M_^3*S_*k_I_^(-3)*((1+I_*k_I_^(-1))*k_M_+S_)^(-4)*v_C_;

    der3_(2,1,1,1) = 6*E_*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_-6*E_*S_*((1+I_*k_I_^(-1))*k_M_+S_)^(-4)*v_C_;
    der3_(2,1,1,3) = 2*S_*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_-2*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    der3_(2,1,3,1) = der3_(2,1,1,3);
    der3_(2,3,1,1) = der3_(2,1,1,3);
    der3_(2,1,1,4) = 4*E_*k_M_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_-6*E_*k_M_*S_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-4)*v_C_;
    der3_(2,1,4,1) = der3_(2,1,1,4);
    der3_(2,4,1,1) = der3_(2,1,1,4);
    der3_(2,1,3,4) = 2*k_M_*S_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_-k_M_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    der3_(2,1,4,3) = der3_(2,1,3,4);
    der3_(2,4,3,1) = der3_(2,1,3,4);
    der3_(2,3,1,4) = der3_(2,1,3,4);
    der3_(2,1,4,4) = -6*E_*k_M_^2*S_*k_I_^(-2)*((1+I_*k_I_^(-1))*k_M_+S_)^(-4)*v_C_+2*E_*k_M_^2*k_I_^(-2)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_;
    der3_(2,4,4,1) = der3_(2,1,4,4);
    der3_(2,4,1,4) = der3_(2,1,4,4);
    der3_(2,3,4,4) = 2*k_M_^2*S_*k_I_^(-2)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_;
    der3_(2,4,4,3) = der3_(2,3,4,4);
    der3_(2,4,3,4) = der3_(2,3,4,4);
    der3_(2,4,4,4) = -6*E_*k_M_^3*S_*k_I_^(-3)*((1+I_*k_I_^(-1))*k_M_+S_)^(-4)*v_C_;



