%
% ci001_hess.m
%
% This MATLAB function computes the Hessians of the vector field
% defined in ci001_vf.m.
%
% hess_(n,i,j) is the second partial derivative of the n-th component
% of the vector field, taken with respect to the i-th and j-th variables.
%
% This file was generated by the program VFGEN (Version:2.4.0)
% Generated on 23-Feb-2009 at 16:56
%
%
function hess_ = ci001_hess(t,x_,p_)
    S_         = x_(1);
    P_         = x_(2);
    E_         = x_(3);
    I_         = x_(4);
    k_M_       = p_(1);
    k_I_       = p_(2);
    v_C_       = p_(3);

    hess_ = zeros(4,4,4);

    hess_(1,1,1) = -2*E_*S_*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_+2*E_*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hess_(1,1,3) = -((1+I_*k_I_^(-1))*k_M_+S_)^(-1)*v_C_+S_*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hess_(1,3,1) = hess_(1,1,3);
    hess_(1,1,4) = -2*E_*k_M_*S_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_+E_*k_M_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hess_(1,4,1) = hess_(1,1,4);
    hess_(1,3,4) = k_M_*S_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hess_(1,4,3) = hess_(1,3,4);
    hess_(1,4,4) = -2*E_*k_M_^2*S_*k_I_^(-2)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_;

    hess_(2,1,1) = 2*E_*S_*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_-2*E_*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hess_(2,1,3) = ((1+I_*k_I_^(-1))*k_M_+S_)^(-1)*v_C_-S_*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hess_(2,3,1) = hess_(2,1,3);
    hess_(2,1,4) = 2*E_*k_M_*S_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_-E_*k_M_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hess_(2,4,1) = hess_(2,1,4);
    hess_(2,3,4) = -k_M_*S_*k_I_^(-1)*((1+I_*k_I_^(-1))*k_M_+S_)^(-2)*v_C_;
    hess_(2,4,3) = hess_(2,3,4);
    hess_(2,4,4) = 2*E_*k_M_^2*S_*k_I_^(-2)*((1+I_*k_I_^(-1))*k_M_+S_)^(-3)*v_C_;



