%
% cyclin_oscillations001_demo.m
%
% MATLAB demo function for the vector field: cyclin_oscillations001
%
% This file was generated by the program VFGEN (Version:2.4.0)
% Generated on 13-Jan-2009 at 16:42
%
%

function cyclin_oscillations001_demo
    figure;
    clf
    set(gcf,'Position',[0 0 250 460]);
    v = [];
    uicontrol('Style','text','Position',[10 440 100 18],'String','C_(0)');
    ui = uicontrol('Style','edit','Position',[115 440 100 18],'String','0.01');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 420 100 18],'String','M_in_(0)');
    ui = uicontrol('Style','edit','Position',[115 420 100 18],'String','0.99');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 400 100 18],'String','M_ac_(0)');
    ui = uicontrol('Style','edit','Position',[115 400 100 18],'String','0.01');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 380 100 18],'String','X_in_(0)');
    ui = uicontrol('Style','edit','Position',[115 380 100 18],'String','0.99');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 360 100 18],'String','X_ac_(0)');
    ui = uicontrol('Style','edit','Position',[115 360 100 18],'String','0.01');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 340 100 18],'String','Res_(0)');
    ui = uicontrol('Style','edit','Position',[115 340 100 18],'String','1');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 320 100 18],'String','k1_');
    ui = uicontrol('Style','edit','Position',[115 320 100 18],'String','0.005');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 300 100 18],'String','k2_');
    ui = uicontrol('Style','edit','Position',[115 300 100 18],'String','0.005');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 280 100 18],'String','k3_');
    ui = uicontrol('Style','edit','Position',[115 280 100 18],'String','0.005');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 260 100 18],'String','k4_');
    ui = uicontrol('Style','edit','Position',[115 260 100 18],'String','0.005');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 240 100 18],'String','vm1_');
    ui = uicontrol('Style','edit','Position',[115 240 100 18],'String','3.0');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 220 100 18],'String','v2_');
    ui = uicontrol('Style','edit','Position',[115 220 100 18],'String','1.5');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 200 100 18],'String','vm3_');
    ui = uicontrol('Style','edit','Position',[115 200 100 18],'String','1.0');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 180 100 18],'String','v4_');
    ui = uicontrol('Style','edit','Position',[115 180 100 18],'String','0.5');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 160 100 18],'String','vi_');
    ui = uicontrol('Style','edit','Position',[115 160 100 18],'String','0.025');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 140 100 18],'String','vd_');
    ui = uicontrol('Style','edit','Position',[115 140 100 18],'String','0.25');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 120 100 18],'String','kc_');
    ui = uicontrol('Style','edit','Position',[115 120 100 18],'String','0.5');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 100 100 18],'String','kD_');
    ui = uicontrol('Style','edit','Position',[115 100 100 18],'String','0.02');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 80 100 18],'String','kd_');
    ui = uicontrol('Style','edit','Position',[115 80 100 18],'String','0.01');
    v = [v; ui];
    uicontrol('Style','text','Position',[10 60 100 18],'String','Stop Time');
    ui = uicontrol('Style','edit','Position',[115 60 100 18],'String','10');
    v = [v; ui];
    ui = uicontrol('Style','checkbox','Position',[10 40 200 18],'String','Separate Axes');
    v = [v; ui];
    uicontrol('Style','pushbutton','Position',[10 20 40 18],'String','Go','Callback',@go_cb,'UserData',v);
end

function go_cb(arg1,arg2)
    v = get(arg1,'UserData');
    ic = zeros(size(v,1)-2,1);
    for k = 1:size(v,1)-2,
        ic(k) = eval(get(v(k),'String'));
        if (isnan(ic(k)))
            ic(k) = 0.0;
        end;
    end;
    stoptime = str2double(get(v(end-1),'String'));
    if (isnan(stoptime))
        stoptime = 0.0;
    end;
    abstol = 1e-9;
    reltol = 1e-7;
    opts = odeset('AbsTol',abstol,'RelTol',reltol,'Jacobian',@cyclin_oscillations001_jac);
    % Change ode45 to ode15s for stiff differential equations.
    [t,z_] = ode45(@cyclin_oscillations001_vf,[0 stoptime],ic(1:6),opts,ic(7:end));
    figure;
    clf;
    a = get(v(end),'Value');
    if (a == 0),
        plot(t,z_);
        xlabel('t');
        legend('C_','M_in_','M_ac_','X_in_','X_ac_','Res_');
    grid on
    else
        subplot(6,1,1);
        plot(t,z_(:,1))
        xlabel('t');
        ylabel('C_')
        grid on
        subplot(6,1,2);
        plot(t,z_(:,2))
        xlabel('t');
        ylabel('M_in_')
        grid on
        subplot(6,1,3);
        plot(t,z_(:,3))
        xlabel('t');
        ylabel('M_ac_')
        grid on
        subplot(6,1,4);
        plot(t,z_(:,4))
        xlabel('t');
        ylabel('X_in_')
        grid on
        subplot(6,1,5);
        plot(t,z_(:,5))
        xlabel('t');
        ylabel('X_ac_')
        grid on
        subplot(6,1,6);
        plot(t,z_(:,6))
        xlabel('t');
        ylabel('Res_')
        grid on
    end
end
