%
% cyclin_oscillations001_hess.m
%
% This MATLAB function computes the Hessians of the vector field
% defined in cyclin_oscillations001_vf.m.
%
% hess_(n,i,j) is the second partial derivative of the n-th component
% of the vector field, taken with respect to the i-th and j-th variables.
%
% This file was generated by the program VFGEN (Version:2.4.0)
% Generated on 13-Jan-2009 at 16:42
%
%
function hess_ = cyclin_oscillations001_hess(t,x_,p_)
    C_         = x_(1);
    M_in_      = x_(2);
    M_ac_      = x_(3);
    X_in_      = x_(4);
    X_ac_      = x_(5);
    Res_       = x_(6);
    k1_        = p_(1);
    k2_        = p_(2);
    k3_        = p_(3);
    k4_        = p_(4);
    vm1_       = p_(5);
    v2_        = p_(6);
    vm3_       = p_(7);
    v4_        = p_(8);
    vi_        = p_(9);
    vd_        = p_(10);
    kc_        = p_(11);
    kD_        = p_(12);
    kd_        = p_(13);

    hess_ = zeros(6,6,6);

    hess_(1,1,1) = 2*X_ac_*(C_+kD_)^(-2)*vd_-2*C_*X_ac_*(C_+kD_)^(-3)*vd_;
    hess_(1,1,5) = C_*(C_+kD_)^(-2)*vd_-(C_+kD_)^(-1)*vd_;
    hess_(1,5,1) = hess_(1,1,5);

    hess_(2,1,1) = 2*vm1_*(k1_+M_in_)^(-1)*M_in_*(kc_+C_)^(-2)-2*vm1_*C_*(k1_+M_in_)^(-1)*M_in_*(kc_+C_)^(-3);
    hess_(2,1,2) = vm1_*(k1_+M_in_)^(-2)*M_in_*(kc_+C_)^(-1)-vm1_*C_*(k1_+M_in_)^(-2)*M_in_*(kc_+C_)^(-2)+vm1_*C_*(k1_+M_in_)^(-1)*(kc_+C_)^(-2)-vm1_*(k1_+M_in_)^(-1)*(kc_+C_)^(-1);
    hess_(2,2,1) = hess_(2,1,2);
    hess_(2,2,2) = -2*vm1_*C_*(k1_+M_in_)^(-3)*M_in_*(kc_+C_)^(-1)+2*vm1_*C_*(k1_+M_in_)^(-2)*(kc_+C_)^(-1);
    hess_(2,3,3) = -2*(M_ac_+k2_)^(-2)*v2_+2*M_ac_*(M_ac_+k2_)^(-3)*v2_;

    hess_(3,1,1) = -2*vm1_*(k1_+M_in_)^(-1)*M_in_*(kc_+C_)^(-2)+2*vm1_*C_*(k1_+M_in_)^(-1)*M_in_*(kc_+C_)^(-3);
    hess_(3,1,2) = -vm1_*(k1_+M_in_)^(-2)*M_in_*(kc_+C_)^(-1)+vm1_*C_*(k1_+M_in_)^(-2)*M_in_*(kc_+C_)^(-2)-vm1_*C_*(k1_+M_in_)^(-1)*(kc_+C_)^(-2)+vm1_*(k1_+M_in_)^(-1)*(kc_+C_)^(-1);
    hess_(3,2,1) = hess_(3,1,2);
    hess_(3,2,2) = 2*vm1_*C_*(k1_+M_in_)^(-3)*M_in_*(kc_+C_)^(-1)-2*vm1_*C_*(k1_+M_in_)^(-2)*(kc_+C_)^(-1);
    hess_(3,3,3) = 2*(M_ac_+k2_)^(-2)*v2_-2*M_ac_*(M_ac_+k2_)^(-3)*v2_;

    hess_(4,3,4) = -vm3_*(X_in_+k3_)^(-1)+vm3_*X_in_*(X_in_+k3_)^(-2);
    hess_(4,4,3) = hess_(4,3,4);
    hess_(4,4,4) = -2*vm3_*M_ac_*X_in_*(X_in_+k3_)^(-3)+2*vm3_*M_ac_*(X_in_+k3_)^(-2);
    hess_(4,5,5) = 2*v4_*X_ac_*(k4_+X_ac_)^(-3)-2*v4_*(k4_+X_ac_)^(-2);

    hess_(5,3,4) = vm3_*(X_in_+k3_)^(-1)-vm3_*X_in_*(X_in_+k3_)^(-2);
    hess_(5,4,3) = hess_(5,3,4);
    hess_(5,4,4) = 2*vm3_*M_ac_*X_in_*(X_in_+k3_)^(-3)-2*vm3_*M_ac_*(X_in_+k3_)^(-2);
    hess_(5,5,5) = -2*v4_*X_ac_*(k4_+X_ac_)^(-3)+2*v4_*(k4_+X_ac_)^(-2);


