/*
 *  ci001_cv.c
 *
 *  CVODE C file for the vector field named: ci001
 *
 *  This file was generated by the program VFGEN (Version:2.4.0)
 *  Generated on 23-Feb-2009 at 16:56
 */

#include <math.h>
/* Include headers for SUNDIALS v2.3.0, CVODE v2.5.0 */
#include <sundials/sundials_types.h>
#include <sundials/sundials_dense.h>
#include <sundials/sundials_nvector.h>
#include <nvector/nvector_serial.h>
#include <cvode/cvode.h>
#include <cvode/cvode_dense.h>
/*
 *  The vector field.
 */

int ci001_vf(realtype t, N_Vector y_, N_Vector f_, void *params)
    {
    realtype S_, P_, E_, I_;
    realtype k_M_, k_I_, v_C_;
    realtype alpha_;
    realtype *p_;

    p_ = (realtype *) params;

    S_         = NV_Ith_S(y_,0);
    P_         = NV_Ith_S(y_,1);
    E_         = NV_Ith_S(y_,2);
    I_         = NV_Ith_S(y_,3);

    k_M_       = p_[0];
    k_I_       = p_[1];
    v_C_       = p_[2];

    alpha_ = E_*S_/( ( I_/k_I_+1.0)*k_M_+S_)*v_C_;

    NV_Ith_S(f_,0) = -alpha_;
    NV_Ith_S(f_,1) = alpha_;
    NV_Ith_S(f_,2) = 0.0;
    NV_Ith_S(f_,3) = 0.0;
    return 0;
    }

/*
 *  The Jacobian.
 */

int ci001_jac(long int N_, DenseMat jac_, realtype t,
                N_Vector y_, N_Vector fy_, void *params,
                N_Vector tmp1, N_Vector tmp2, N_Vector tmp3)
    {
    realtype S_, P_, E_, I_;
    realtype k_M_, k_I_, v_C_;
    realtype *p_;

    p_ = (realtype *) params;

    S_         = NV_Ith_S(y_,0);
    P_         = NV_Ith_S(y_,1);
    E_         = NV_Ith_S(y_,2);
    I_         = NV_Ith_S(y_,3);

    k_M_       = p_[0];
    k_I_       = p_[1];
    v_C_       = p_[2];

    DENSE_ELEM(jac_, 0, 0) =  E_*S_/pow( ( I_/k_I_+1.0)*k_M_+S_,2.0)*v_C_-E_/( ( I_/k_I_+1.0)*k_M_+S_)*v_C_;
    DENSE_ELEM(jac_, 0, 2) = -S_/( ( I_/k_I_+1.0)*k_M_+S_)*v_C_;
    DENSE_ELEM(jac_, 0, 3) = E_*k_M_*S_/k_I_/pow( ( I_/k_I_+1.0)*k_M_+S_,2.0)*v_C_;
    DENSE_ELEM(jac_, 1, 0) = -E_*S_/pow( ( I_/k_I_+1.0)*k_M_+S_,2.0)*v_C_+E_/( ( I_/k_I_+1.0)*k_M_+S_)*v_C_;
    DENSE_ELEM(jac_, 1, 2) = S_/( ( I_/k_I_+1.0)*k_M_+S_)*v_C_;
    DENSE_ELEM(jac_, 1, 3) = -E_*k_M_*S_/k_I_/pow( ( I_/k_I_+1.0)*k_M_+S_,2.0)*v_C_;
    return 0;
    }
