/*
 *  cyclin_oscillations001_cv.c
 *
 *  CVODE C file for the vector field named: cyclin_oscillations001
 *
 *  This file was generated by the program VFGEN (Version:2.4.0)
 *  Generated on 13-Jan-2009 at 16:42
 */

#include <math.h>
/* Include headers for SUNDIALS v2.3.0, CVODE v2.5.0 */
#include <sundials/sundials_types.h>
#include <sundials/sundials_dense.h>
#include <sundials/sundials_nvector.h>
#include <nvector/nvector_serial.h>
#include <cvode/cvode.h>
#include <cvode/cvode_dense.h>
/*
 *  The vector field.
 */

int cyclin_oscillations001_vf(realtype t, N_Vector y_, N_Vector f_, void *params)
    {
    realtype C_, M_in_, M_ac_, X_in_, X_ac_, Res_;
    realtype k1_, k2_, k3_, k4_, vm1_, v2_, vm3_, v4_, vi_, vd_, kc_, kD_, kd_;
    realtype synthesisC_, activationM_, inhibitionM_, activationX_, inhibitionX_, degradationC_, degradationCX_;
    realtype *p_;

    p_ = (realtype *) params;

    C_         = NV_Ith_S(y_,0);
    M_in_      = NV_Ith_S(y_,1);
    M_ac_      = NV_Ith_S(y_,2);
    X_in_      = NV_Ith_S(y_,3);
    X_ac_      = NV_Ith_S(y_,4);
    Res_       = NV_Ith_S(y_,5);

    k1_        = p_[0];
    k2_        = p_[1];
    k3_        = p_[2];
    k4_        = p_[3];
    vm1_       = p_[4];
    v2_        = p_[5];
    vm3_       = p_[6];
    v4_        = p_[7];
    vi_        = p_[8];
    vd_        = p_[9];
    kc_        = p_[10];
    kD_        = p_[11];
    kd_        = p_[12];

    synthesisC_ = vi_;
    activationM_ = vm1_*C_/( k1_+M_in_)*M_in_/( kc_+C_);
    inhibitionM_ = M_ac_/( M_ac_+k2_)*v2_;
    activationX_ = vm3_*M_ac_*X_in_/( X_in_+k3_);
    inhibitionX_ = v4_*X_ac_/( k4_+X_ac_);
    degradationC_ = C_*kd_;
    degradationCX_ = C_*X_ac_/( C_+kD_)*vd_;

    NV_Ith_S(f_,0) = -degradationCX_+synthesisC_-degradationC_;
    NV_Ith_S(f_,1) =  inhibitionM_-activationM_;
    NV_Ith_S(f_,2) = -inhibitionM_+activationM_;
    NV_Ith_S(f_,3) = -activationX_+inhibitionX_;
    NV_Ith_S(f_,4) =  activationX_-inhibitionX_;
    NV_Ith_S(f_,5) = 0.0;
    return 0;
    }

/*
 *  The Jacobian.
 */

int cyclin_oscillations001_jac(long int N_, DenseMat jac_, realtype t,
                N_Vector y_, N_Vector fy_, void *params,
                N_Vector tmp1, N_Vector tmp2, N_Vector tmp3)
    {
    realtype C_, M_in_, M_ac_, X_in_, X_ac_, Res_;
    realtype k1_, k2_, k3_, k4_, vm1_, v2_, vm3_, v4_, vi_, vd_, kc_, kD_, kd_;
    realtype *p_;

    p_ = (realtype *) params;

    C_         = NV_Ith_S(y_,0);
    M_in_      = NV_Ith_S(y_,1);
    M_ac_      = NV_Ith_S(y_,2);
    X_in_      = NV_Ith_S(y_,3);
    X_ac_      = NV_Ith_S(y_,4);
    Res_       = NV_Ith_S(y_,5);

    k1_        = p_[0];
    k2_        = p_[1];
    k3_        = p_[2];
    k4_        = p_[3];
    vm1_       = p_[4];
    v2_        = p_[5];
    vm3_       = p_[6];
    v4_        = p_[7];
    vi_        = p_[8];
    vd_        = p_[9];
    kc_        = p_[10];
    kD_        = p_[11];
    kd_        = p_[12];

    DENSE_ELEM(jac_, 0, 0) =  C_*X_ac_/pow( C_+kD_,2.0)*vd_-X_ac_/( C_+kD_)*vd_-kd_;
    DENSE_ELEM(jac_, 0, 4) = -C_/( C_+kD_)*vd_;
    DENSE_ELEM(jac_, 1, 0) = -vm1_/( k1_+M_in_)*M_in_/( kc_+C_)+vm1_*C_/( k1_+M_in_)*M_in_/pow( kc_+C_,2.0);
    DENSE_ELEM(jac_, 1, 1) = -vm1_*C_/( k1_+M_in_)/( kc_+C_)+vm1_*C_/pow( k1_+M_in_,2.0)*M_in_/( kc_+C_);
    DENSE_ELEM(jac_, 1, 2) =  1.0/( M_ac_+k2_)*v2_-M_ac_/pow( M_ac_+k2_,2.0)*v2_;
    DENSE_ELEM(jac_, 2, 0) =  vm1_/( k1_+M_in_)*M_in_/( kc_+C_)-vm1_*C_/( k1_+M_in_)*M_in_/pow( kc_+C_,2.0);
    DENSE_ELEM(jac_, 2, 1) =  vm1_*C_/( k1_+M_in_)/( kc_+C_)-vm1_*C_/pow( k1_+M_in_,2.0)*M_in_/( kc_+C_);
    DENSE_ELEM(jac_, 2, 2) = -1.0/( M_ac_+k2_)*v2_+M_ac_/pow( M_ac_+k2_,2.0)*v2_;
    DENSE_ELEM(jac_, 3, 2) = -vm3_*X_in_/( X_in_+k3_);
    DENSE_ELEM(jac_, 3, 3) =  vm3_*M_ac_*X_in_/pow( X_in_+k3_,2.0)-vm3_*M_ac_/( X_in_+k3_);
    DENSE_ELEM(jac_, 3, 4) =  v4_/( k4_+X_ac_)-v4_*X_ac_/pow( k4_+X_ac_,2.0);
    DENSE_ELEM(jac_, 4, 2) = vm3_*X_in_/( X_in_+k3_);
    DENSE_ELEM(jac_, 4, 3) = -vm3_*M_ac_*X_in_/pow( X_in_+k3_,2.0)+vm3_*M_ac_/( X_in_+k3_);
    DENSE_ELEM(jac_, 4, 4) = -v4_/( k4_+X_ac_)+v4_*X_ac_/pow( k4_+X_ac_,2.0);
    return 0;
    }
