/*
 *  dd001_cv.c
 *
 *  CVODE C file for the vector field named: dd001
 *
 *  This file was generated by the program VFGEN (Version:2.4.0)
 *  Generated on 22-Apr-2009 at 09:07
 */

#include <math.h>
/* Include headers for SUNDIALS v2.3.0, CVODE v2.5.0 */
#include <sundials/sundials_types.h>
#include <sundials/sundials_dense.h>
#include <sundials/sundials_nvector.h>
#include <nvector/nvector_serial.h>
#include <cvode/cvode.h>
#include <cvode/cvode_dense.h>
/*
 *  The vector field.
 */

int dd001_vf(realtype t, N_Vector y_, N_Vector f_, void *params)
    {
    realtype S1_, S2_, S3_, Null_;
    realtype k1_, k2_, k3_, k4_;
    realtype c1_, c2_, c3_, c4_;
    realtype *p_;

    p_ = (realtype *) params;

    S1_        = NV_Ith_S(y_,0);
    S2_        = NV_Ith_S(y_,1);
    S3_        = NV_Ith_S(y_,2);
    Null_      = NV_Ith_S(y_,3);

    k1_        = p_[0];
    k2_        = p_[1];
    k3_        = p_[2];
    k4_        = p_[3];

    c1_ = k1_*S1_;
    c2_ = (1.0/2.0)*( S1_-1.0)*k2_*S1_;
    c3_ = S2_*k3_;
    c4_ = S2_*k4_;

    NV_Ith_S(f_,0) = -c2_+c3_-c1_;
    NV_Ith_S(f_,1) =  c2_-c3_-c4_;
    NV_Ith_S(f_,2) = c4_;
    NV_Ith_S(f_,3) = c1_;
    return 0;
    }

/*
 *  The Jacobian.
 */

int dd001_jac(long int N_, DenseMat jac_, realtype t,
                N_Vector y_, N_Vector fy_, void *params,
                N_Vector tmp1, N_Vector tmp2, N_Vector tmp3)
    {
    realtype S1_, S2_, S3_, Null_;
    realtype k1_, k2_, k3_, k4_;
    realtype *p_;

    p_ = (realtype *) params;

    S1_        = NV_Ith_S(y_,0);
    S2_        = NV_Ith_S(y_,1);
    S3_        = NV_Ith_S(y_,2);
    Null_      = NV_Ith_S(y_,3);

    k1_        = p_[0];
    k2_        = p_[1];
    k3_        = p_[2];
    k4_        = p_[3];

    DENSE_ELEM(jac_, 0, 0) = -( S1_-1.0)*k2_/2.0-k1_-k2_*S1_/2.0;
    DENSE_ELEM(jac_, 0, 1) = k3_;
    DENSE_ELEM(jac_, 1, 0) =  ( S1_-1.0)*k2_/2.0+k2_*S1_/2.0;
    DENSE_ELEM(jac_, 1, 1) = -k4_-k3_;
    DENSE_ELEM(jac_, 2, 1) = k4_;
    DENSE_ELEM(jac_, 3, 0) = k1_;
    return 0;
    }
