/*
 *  sirr001_cv.c
 *
 *  CVODE C file for the vector field named: sirr001
 *
 *  This file was generated by the program VFGEN (Version:2.4.0)
 *  Generated on 23-Feb-2009 at 09:40
 */

#include <math.h>
/* Include headers for SUNDIALS v2.3.0, CVODE v2.5.0 */
#include <sundials/sundials_types.h>
#include <sundials/sundials_dense.h>
#include <sundials/sundials_nvector.h>
#include <nvector/nvector_serial.h>
#include <cvode/cvode.h>
#include <cvode/cvode_dense.h>
/*
 *  The vector field.
 */

int sirr001_vf(realtype t, N_Vector y_, N_Vector f_, void *params)
    {
    realtype S_, I_, R_;
    realtype k1_, k2_, k3_;
    realtype infect_, recover_, relapse_;
    realtype *p_;

    p_ = (realtype *) params;

    S_         = NV_Ith_S(y_,0);
    I_         = NV_Ith_S(y_,1);
    R_         = NV_Ith_S(y_,2);

    k1_        = p_[0];
    k2_        = p_[1];
    k3_        = p_[2];

    infect_ = k1_*S_*I_;
    recover_ = k2_*I_;
    relapse_ = R_*k3_;

    NV_Ith_S(f_,0) = -infect_+relapse_;
    NV_Ith_S(f_,1) =  infect_-recover_;
    NV_Ith_S(f_,2) =  recover_-relapse_;
    return 0;
    }

/*
 *  The Jacobian.
 */

int sirr001_jac(long int N_, DenseMat jac_, realtype t,
                N_Vector y_, N_Vector fy_, void *params,
                N_Vector tmp1, N_Vector tmp2, N_Vector tmp3)
    {
    realtype S_, I_, R_;
    realtype k1_, k2_, k3_;
    realtype *p_;

    p_ = (realtype *) params;

    S_         = NV_Ith_S(y_,0);
    I_         = NV_Ith_S(y_,1);
    R_         = NV_Ith_S(y_,2);

    k1_        = p_[0];
    k2_        = p_[1];
    k3_        = p_[2];

    DENSE_ELEM(jac_, 0, 0) = -k1_*I_;
    DENSE_ELEM(jac_, 0, 1) = -k1_*S_;
    DENSE_ELEM(jac_, 0, 2) = k3_;
    DENSE_ELEM(jac_, 1, 0) = k1_*I_;
    DENSE_ELEM(jac_, 1, 1) = -k2_+k1_*S_;
    DENSE_ELEM(jac_, 2, 1) = k2_;
    DENSE_ELEM(jac_, 2, 2) = -k3_;
    return 0;
    }
