%
% cyclin_oscillations001.m
%
% MATLAB file to be used with MATCONT.
%
% This file was generated by the program VFGEN (Version:2.4.0)
% Generated on 13-Jan-2009 at 16:43
%
%
function out = cyclin_oscillations001
    out{1} = @cyclin_oscillations001_init;
    out{2} = @cyclin_oscillations001_vf;
    out{3} = @cyclin_oscillations001_jac;
    out{4} = @cyclin_oscillations001_jacp;
    out{5} = @cyclin_oscillations001_hess;
    out{6} = @cyclin_oscillations001_hessp;
    out{7} = @cyclin_oscillations001_der3;
    out{8} = [];
    out{9} = [];

%--------------------------------------------------

function [tspan, y0, options] = cyclin_oscillations001_init

    tspan = [0; 10];

    % Get the constants and default parameters, because the default
    % initial conditions can depend on them.
    k1_ = 0.005;
    k2_ = 0.005;
    k3_ = 0.005;
    k4_ = 0.005;
    vm1_ = 3.0;
    v2_ = 1.5;
    vm3_ = 1.0;
    v4_ = 0.5;
    vi_ = 0.025;
    vd_ = 0.25;
    kc_ = 0.5;
    kD_ = 0.02;
    kd_ = 0.01;
    % Set the default initial point.
    y0 = zeros(6,1);
    y0(1) = 0.01;
    y0(2) = 0.99;
    y0(3) = 0.01;
    y0(4) = 0.99;
    y0(5) = 0.01;
    y0(6) = 1;

    handles = feval(@cyclin_oscillations001);
    options = odeset('Jacobian',handles(3),'JacobianP',handles(4), ...
                     'Hessians',handles(5),'HessiansP',handles(6), ...
                     'Der3',handles(7) );

%--------------------------------------------------
%
% The vector field
%
function vf_ = cyclin_oscillations001_vf(t,x_,k1_,k2_,k3_,k4_,vm1_,v2_,vm3_,v4_,vi_,vd_,kc_,kD_,kd_)
    C_         = x_(1);
    M_in_      = x_(2);
    M_ac_      = x_(3);
    X_in_      = x_(4);
    X_ac_      = x_(5);
    Res_       = x_(6);

    synthesisC_ = vi_;
    activationM_ = M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-1)*C_;
    inhibitionM_ = v2_*(M_ac_+k2_)^(-1)*M_ac_;
    activationX_ = (k3_+X_in_)^(-1)*vm3_*M_ac_*X_in_;
    inhibitionX_ = X_ac_*(X_ac_+k4_)^(-1)*v4_;
    degradationC_ = kd_*C_;
    degradationCX_ = X_ac_*vd_*(C_+kD_)^(-1)*C_;

    vf_ = zeros(6,1);
    vf_(1) = -degradationC_-degradationCX_+synthesisC_;
    vf_(2) = -activationM_+inhibitionM_;
    vf_(3) = activationM_-inhibitionM_;
    vf_(4) = -activationX_+inhibitionX_;
    vf_(5) = activationX_-inhibitionX_;
    vf_(6) = 0;

%--------------------------------------------------
%
% The Jacobian of the vector field with respect to the variables
%
function jac_ = cyclin_oscillations001_jac(t,x_,k1_,k2_,k3_,k4_,vm1_,v2_,vm3_,v4_,vi_,vd_,kc_,kD_,kd_)
    C_         = x_(1);
    M_in_      = x_(2);
    M_ac_      = x_(3);
    X_in_      = x_(4);
    X_ac_      = x_(5);
    Res_       = x_(6);

    jac_ = zeros(6,6);
    jac_(1,1) = -kd_+X_ac_*vd_*(C_+kD_)^(-2)*C_-X_ac_*vd_*(C_+kD_)^(-1);
    jac_(1,5) = -vd_*(C_+kD_)^(-1)*C_;
    jac_(2,1) = -M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-1)+M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-2)*C_;
    jac_(2,2) = M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-1)*C_-(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-1)*C_;
    jac_(2,3) = -v2_*(M_ac_+k2_)^(-2)*M_ac_+v2_*(M_ac_+k2_)^(-1);
    jac_(3,1) = M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-1)-M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-2)*C_;
    jac_(3,2) = -M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-1)*C_+(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-1)*C_;
    jac_(3,3) = v2_*(M_ac_+k2_)^(-2)*M_ac_-v2_*(M_ac_+k2_)^(-1);
    jac_(4,3) = -(k3_+X_in_)^(-1)*vm3_*X_in_;
    jac_(4,4) = (k3_+X_in_)^(-2)*vm3_*M_ac_*X_in_-(k3_+X_in_)^(-1)*vm3_*M_ac_;
    jac_(4,5) = (X_ac_+k4_)^(-1)*v4_-X_ac_*(X_ac_+k4_)^(-2)*v4_;
    jac_(5,3) = (k3_+X_in_)^(-1)*vm3_*X_in_;
    jac_(5,4) = -(k3_+X_in_)^(-2)*vm3_*M_ac_*X_in_+(k3_+X_in_)^(-1)*vm3_*M_ac_;
    jac_(5,5) = -(X_ac_+k4_)^(-1)*v4_+X_ac_*(X_ac_+k4_)^(-2)*v4_;

%--------------------------------------------------
%
% The Jacobian of the vector field with respect to the parameters
%
function jacp_ = cyclin_oscillations001_jacp(t,x_,k1_,k2_,k3_,k4_,vm1_,v2_,vm3_,v4_,vi_,vd_,kc_,kD_,kd_)
    C_         = x_(1);
    M_in_      = x_(2);
    M_ac_      = x_(3);
    X_in_      = x_(4);
    X_ac_      = x_(5);
    Res_       = x_(6);

    jacp_ = zeros(6,13);
    jacp_(1,9) = 1;
    jacp_(1,10) = -X_ac_*(C_+kD_)^(-1)*C_;
    jacp_(1,12) = X_ac_*vd_*(C_+kD_)^(-2)*C_;
    jacp_(1,13) = -C_;
    jacp_(2,1) = M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-1)*C_;
    jacp_(2,2) = -v2_*(M_ac_+k2_)^(-2)*M_ac_;
    jacp_(2,5) = -M_in_*(M_in_+k1_)^(-1)*(kc_+C_)^(-1)*C_;
    jacp_(2,6) = (M_ac_+k2_)^(-1)*M_ac_;
    jacp_(2,11) = M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-2)*C_;
    jacp_(3,1) = -M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-1)*C_;
    jacp_(3,2) = v2_*(M_ac_+k2_)^(-2)*M_ac_;
    jacp_(3,5) = M_in_*(M_in_+k1_)^(-1)*(kc_+C_)^(-1)*C_;
    jacp_(3,6) = -(M_ac_+k2_)^(-1)*M_ac_;
    jacp_(3,11) = -M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-2)*C_;
    jacp_(4,3) = (k3_+X_in_)^(-2)*vm3_*M_ac_*X_in_;
    jacp_(4,4) = -X_ac_*(X_ac_+k4_)^(-2)*v4_;
    jacp_(4,7) = -(k3_+X_in_)^(-1)*M_ac_*X_in_;
    jacp_(4,8) = X_ac_*(X_ac_+k4_)^(-1);
    jacp_(5,3) = -(k3_+X_in_)^(-2)*vm3_*M_ac_*X_in_;
    jacp_(5,4) = X_ac_*(X_ac_+k4_)^(-2)*v4_;
    jacp_(5,7) = (k3_+X_in_)^(-1)*M_ac_*X_in_;
    jacp_(5,8) = -X_ac_*(X_ac_+k4_)^(-1);

%--------------------------------------------------
%
% The Hessians function.
% This function returns a 3D matrix.
% hess_(n,:,:) is the Hessian of the n-th component of the vector field. That is,
% hess_(n,i,j) is the second partial derivative of the n-th component
% of the vector field, taken with respect to the i-th and j-th variables.
%
function hess_ = cyclin_oscillations001_hess(t,x_,k1_,k2_,k3_,k4_,vm1_,v2_,vm3_,v4_,vi_,vd_,kc_,kD_,kd_)
    C_         = x_(1);
    M_in_      = x_(2);
    M_ac_      = x_(3);
    X_in_      = x_(4);
    X_ac_      = x_(5);
    Res_       = x_(6);

    hess_ = zeros(6,6,6);

    hess_(1,1,1) = 2*X_ac_*vd_*(C_+kD_)^(-2)-2*X_ac_*vd_*(C_+kD_)^(-3)*C_;
    hess_(1,1,5) = -vd_*(C_+kD_)^(-1)+vd_*(C_+kD_)^(-2)*C_;
    hess_(1,5,1) = hess_(1,1,5);

    hess_(2,1,1) = -2*M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-3)*C_+2*M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-2);
    hess_(2,1,2) = (M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-2)*C_-M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-2)*C_+M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-1)-(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-1);
    hess_(2,2,1) = hess_(2,1,2);
    hess_(2,2,2) = -2*M_in_*(M_in_+k1_)^(-3)*vm1_*(kc_+C_)^(-1)*C_+2*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-1)*C_;
    hess_(2,3,3) = -2*v2_*(M_ac_+k2_)^(-2)+2*v2_*(M_ac_+k2_)^(-3)*M_ac_;

    hess_(3,1,1) = 2*M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-3)*C_-2*M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-2);
    hess_(3,1,2) = -(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-2)*C_+M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-2)*C_-M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-1)+(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-1);
    hess_(3,2,1) = hess_(3,1,2);
    hess_(3,2,2) = 2*M_in_*(M_in_+k1_)^(-3)*vm1_*(kc_+C_)^(-1)*C_-2*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-1)*C_;
    hess_(3,3,3) = 2*v2_*(M_ac_+k2_)^(-2)-2*v2_*(M_ac_+k2_)^(-3)*M_ac_;

    hess_(4,3,4) = (k3_+X_in_)^(-2)*vm3_*X_in_-(k3_+X_in_)^(-1)*vm3_;
    hess_(4,4,3) = hess_(4,3,4);
    hess_(4,4,4) = 2*(k3_+X_in_)^(-2)*vm3_*M_ac_-2*(k3_+X_in_)^(-3)*vm3_*M_ac_*X_in_;
    hess_(4,5,5) = -2*(X_ac_+k4_)^(-2)*v4_+2*X_ac_*(X_ac_+k4_)^(-3)*v4_;

    hess_(5,3,4) = -(k3_+X_in_)^(-2)*vm3_*X_in_+(k3_+X_in_)^(-1)*vm3_;
    hess_(5,4,3) = hess_(5,3,4);
    hess_(5,4,4) = -2*(k3_+X_in_)^(-2)*vm3_*M_ac_+2*(k3_+X_in_)^(-3)*vm3_*M_ac_*X_in_;
    hess_(5,5,5) = 2*(X_ac_+k4_)^(-2)*v4_-2*X_ac_*(X_ac_+k4_)^(-3)*v4_;


%--------------------------------------------------
%
% The Hessians with respect to the parameters.
% This function returns a 3D matrix.
% hessp_(n,i,j) is the second partial derivative of the n-th component
% of the vector field, taken with respect to the i-th variable and
% the j-th parameter.
%
function hessp_ = cyclin_oscillations001_hessp(t,x_,k1_,k2_,k3_,k4_,vm1_,v2_,vm3_,v4_,vi_,vd_,kc_,kD_,kd_)
    C_         = x_(1);
    M_in_      = x_(2);
    M_ac_      = x_(3);
    X_in_      = x_(4);
    X_ac_      = x_(5);
    Res_       = x_(6);

    hessp_ = zeros(6,6,13);

    hessp_(1,1,10) = -X_ac_*(C_+kD_)^(-1)+X_ac_*(C_+kD_)^(-2)*C_;
    hessp_(1,1,12) = X_ac_*vd_*(C_+kD_)^(-2)-2*X_ac_*vd_*(C_+kD_)^(-3)*C_;
    hessp_(1,1,13) = -1;
    hessp_(1,5,10) = -(C_+kD_)^(-1)*C_;
    hessp_(1,5,12) = vd_*(C_+kD_)^(-2)*C_;

    hessp_(2,1,1) = -M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-2)*C_+M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-1);
    hessp_(2,1,5) = -M_in_*(M_in_+k1_)^(-1)*(kc_+C_)^(-1)+M_in_*(M_in_+k1_)^(-1)*(kc_+C_)^(-2)*C_;
    hessp_(2,1,11) = -2*M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-3)*C_+M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-2);
    hessp_(2,2,1) = -2*M_in_*(M_in_+k1_)^(-3)*vm1_*(kc_+C_)^(-1)*C_+(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-1)*C_;
    hessp_(2,2,5) = M_in_*(M_in_+k1_)^(-2)*(kc_+C_)^(-1)*C_-(M_in_+k1_)^(-1)*(kc_+C_)^(-1)*C_;
    hessp_(2,2,11) = (M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-2)*C_-M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-2)*C_;
    hessp_(2,3,2) = -v2_*(M_ac_+k2_)^(-2)+2*v2_*(M_ac_+k2_)^(-3)*M_ac_;
    hessp_(2,3,6) = (M_ac_+k2_)^(-1)-(M_ac_+k2_)^(-2)*M_ac_;

    hessp_(3,1,1) = M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-2)*C_-M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-1);
    hessp_(3,1,5) = M_in_*(M_in_+k1_)^(-1)*(kc_+C_)^(-1)-M_in_*(M_in_+k1_)^(-1)*(kc_+C_)^(-2)*C_;
    hessp_(3,1,11) = 2*M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-3)*C_-M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-2);
    hessp_(3,2,1) = 2*M_in_*(M_in_+k1_)^(-3)*vm1_*(kc_+C_)^(-1)*C_-(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-1)*C_;
    hessp_(3,2,5) = -M_in_*(M_in_+k1_)^(-2)*(kc_+C_)^(-1)*C_+(M_in_+k1_)^(-1)*(kc_+C_)^(-1)*C_;
    hessp_(3,2,11) = -(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-2)*C_+M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-2)*C_;
    hessp_(3,3,2) = v2_*(M_ac_+k2_)^(-2)-2*v2_*(M_ac_+k2_)^(-3)*M_ac_;
    hessp_(3,3,6) = -(M_ac_+k2_)^(-1)+(M_ac_+k2_)^(-2)*M_ac_;

    hessp_(4,3,3) = (k3_+X_in_)^(-2)*vm3_*X_in_;
    hessp_(4,3,7) = -(k3_+X_in_)^(-1)*X_in_;
    hessp_(4,4,3) = (k3_+X_in_)^(-2)*vm3_*M_ac_-2*(k3_+X_in_)^(-3)*vm3_*M_ac_*X_in_;
    hessp_(4,4,7) = (k3_+X_in_)^(-2)*M_ac_*X_in_-(k3_+X_in_)^(-1)*M_ac_;
    hessp_(4,5,4) = -(X_ac_+k4_)^(-2)*v4_+2*X_ac_*(X_ac_+k4_)^(-3)*v4_;
    hessp_(4,5,8) = (X_ac_+k4_)^(-1)-X_ac_*(X_ac_+k4_)^(-2);

    hessp_(5,3,3) = -(k3_+X_in_)^(-2)*vm3_*X_in_;
    hessp_(5,3,7) = (k3_+X_in_)^(-1)*X_in_;
    hessp_(5,4,3) = -(k3_+X_in_)^(-2)*vm3_*M_ac_+2*(k3_+X_in_)^(-3)*vm3_*M_ac_*X_in_;
    hessp_(5,4,7) = -(k3_+X_in_)^(-2)*M_ac_*X_in_+(k3_+X_in_)^(-1)*M_ac_;
    hessp_(5,5,4) = (X_ac_+k4_)^(-2)*v4_-2*X_ac_*(X_ac_+k4_)^(-3)*v4_;
    hessp_(5,5,8) = -(X_ac_+k4_)^(-1)+X_ac_*(X_ac_+k4_)^(-2);


%--------------------------------------------------
%
% Third derivatives of the vector field.
% This function returns a 4D matrix.
% der3_(n,i,j,k) is the third partial derivative of the n-th component
% of the vector field, taken with respect to the i-th, j-th and k-th variables.
%
function der3_ = cyclin_oscillations001_der3(t,x_,k1_,k2_,k3_,k4_,vm1_,v2_,vm3_,v4_,vi_,vd_,kc_,kD_,kd_)
    C_         = x_(1);
    M_in_      = x_(2);
    M_ac_      = x_(3);
    X_in_      = x_(4);
    X_ac_      = x_(5);
    Res_       = x_(6);

    der3_ = zeros(6,6,6,6);

    der3_(1,1,1,1) = 6*X_ac_*vd_*(C_+kD_)^(-4)*C_-6*X_ac_*vd_*(C_+kD_)^(-3);
    der3_(1,1,1,5) = -2*vd_*(C_+kD_)^(-3)*C_+2*vd_*(C_+kD_)^(-2);
    der3_(1,1,5,1) = der3_(1,1,1,5);
    der3_(1,5,1,1) = der3_(1,1,1,5);

    der3_(2,1,1,1) = 6*M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-4)*C_-6*M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-3);
    der3_(2,1,1,2) = 2*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-2)-2*M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-2)-2*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-3)*C_+2*M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-3)*C_;
    der3_(2,1,2,1) = der3_(2,1,1,2);
    der3_(2,2,1,1) = der3_(2,1,1,2);
    der3_(2,1,2,2) = -2*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-2)*C_+2*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-1)-2*M_in_*(M_in_+k1_)^(-3)*vm1_*(kc_+C_)^(-1)+2*M_in_*(M_in_+k1_)^(-3)*vm1_*(kc_+C_)^(-2)*C_;
    der3_(2,2,2,1) = der3_(2,1,2,2);
    der3_(2,2,1,2) = der3_(2,1,2,2);
    der3_(2,2,2,2) = -6*(M_in_+k1_)^(-3)*vm1_*(kc_+C_)^(-1)*C_+6*M_in_*(M_in_+k1_)^(-4)*vm1_*(kc_+C_)^(-1)*C_;
    der3_(2,3,3,3) = 6*v2_*(M_ac_+k2_)^(-3)-6*v2_*(M_ac_+k2_)^(-4)*M_ac_;

    der3_(3,1,1,1) = -6*M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-4)*C_+6*M_in_*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-3);
    der3_(3,1,1,2) = -2*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-2)+2*M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-2)+2*(M_in_+k1_)^(-1)*vm1_*(kc_+C_)^(-3)*C_-2*M_in_*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-3)*C_;
    der3_(3,1,2,1) = der3_(3,1,1,2);
    der3_(3,2,1,1) = der3_(3,1,1,2);
    der3_(3,1,2,2) = 2*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-2)*C_-2*(M_in_+k1_)^(-2)*vm1_*(kc_+C_)^(-1)+2*M_in_*(M_in_+k1_)^(-3)*vm1_*(kc_+C_)^(-1)-2*M_in_*(M_in_+k1_)^(-3)*vm1_*(kc_+C_)^(-2)*C_;
    der3_(3,2,2,1) = der3_(3,1,2,2);
    der3_(3,2,1,2) = der3_(3,1,2,2);
    der3_(3,2,2,2) = 6*(M_in_+k1_)^(-3)*vm1_*(kc_+C_)^(-1)*C_-6*M_in_*(M_in_+k1_)^(-4)*vm1_*(kc_+C_)^(-1)*C_;
    der3_(3,3,3,3) = -6*v2_*(M_ac_+k2_)^(-3)+6*v2_*(M_ac_+k2_)^(-4)*M_ac_;

    der3_(4,3,4,4) = 2*(k3_+X_in_)^(-2)*vm3_-2*(k3_+X_in_)^(-3)*vm3_*X_in_;
    der3_(4,4,4,3) = der3_(4,3,4,4);
    der3_(4,4,3,4) = der3_(4,3,4,4);
    der3_(4,4,4,4) = 6*(k3_+X_in_)^(-4)*vm3_*M_ac_*X_in_-6*(k3_+X_in_)^(-3)*vm3_*M_ac_;
    der3_(4,5,5,5) = 6*(X_ac_+k4_)^(-3)*v4_-6*X_ac_*(X_ac_+k4_)^(-4)*v4_;

    der3_(5,3,4,4) = -2*(k3_+X_in_)^(-2)*vm3_+2*(k3_+X_in_)^(-3)*vm3_*X_in_;
    der3_(5,4,4,3) = der3_(5,3,4,4);
    der3_(5,4,3,4) = der3_(5,3,4,4);
    der3_(5,4,4,4) = -6*(k3_+X_in_)^(-4)*vm3_*M_ac_*X_in_+6*(k3_+X_in_)^(-3)*vm3_*M_ac_;
    der3_(5,5,5,5) = -6*(X_ac_+k4_)^(-3)*v4_+6*X_ac_*(X_ac_+k4_)^(-4)*v4_;


